import Phaser from 'phaser'
import WebFont from 'webfontloader'

export default class extends Phaser.State {
  init () {
    this.stage.backgroundColor = '#4a98b9'
    this.fontsReady = false
    this.fontsLoaded = this.fontsLoaded.bind(this)
  }

  preload () {
    this.stage.backgroundColor = '#4a98b9'
    WebFont.load({
      google: {
        families: ['Bungee', 'Nunito']
      },
      active: this.fontsLoaded
    });

    let text = this.add.text(this.world.centerX, 290, 'Loading...', { font: '80px', fill: "config.labelColor", align: 'center' })
    text.anchor.setTo(0.5, 0.5);

    this.load.audio('bg_sound_monody', ['assets/sound/background_monody.mp3', 'assets/sound/background_monody.ogg']);
    this.load.image('object', 'assets/images/mushroom2.png')
    this.load.image('loaderBg', './assets/images/loader-bg.png')
    this.load.image('loaderBar', './assets/images/loader-bar.png')
    this.load.image('startRouter', './assets/images/game/start_router_48.png')
    this.load.image('smallRouter', './assets/images/game/router_small_48.png')
    this.load.image('bigRouter', './assets/images/game/router_big_48.png')
    this.load.image('smallRouterBuy', './assets/images/game/router_small_money_48.png')
    this.load.image('bigRouterBuy', './assets/images/game/router_big_money_48.png')
    this.load.image('loading_circle', './assets/images/loading_circle.png')
    this.load.image('house2', './assets/images/game/house_big.png')
    this.load.image('house1', './assets/images/game/house_medium.png')
    this.load.image('house0', './assets/images/game/house_small.png')
    this.load.image('people', './assets/images/game/people.png')
    this.load.image('enemy_people', './assets/images/game/people.png')
    this.load.image('wifi', './assets/images/game/wifi_48.png')
  }

  render () {
    if (this.fontsReady) {
      this.state.start('Splash')
    }
  }

  fontsLoaded () {
    this.fontsReady = true
  }
}
