/* globals __DEV__ */
import Phaser from 'phaser'

var snd;
var logoInterval;

var text = '';
var line = [];
var wordIndex = 0;
var lineIndex = 0;

var wordDelay = 40;
var lineDelay = 300;

var content = [
    "How to play:",
    "- Build Wifi routers and get money from every customer living in that range.",
    "- For different building types you can gain 6, 12 or 24 customers.",
    "- The range of one router has to touch another one.",
    "\nHow to win:",
    "- Reach the $1000 first and win! But be aware, routers are not for free.",
    "\n\nMade with ♥ by Dominik Meyer, Martin Jainta, Rustam Miyliyev, Stanislav Saprankou."
];
export default class extends Phaser.State {
  init () {
    this.stage.backgroundColor = '#4a98b9'
  }
  preload () {
    game.load.image('wifi_logo0', 'assets/images/wifi_logo0.png');
    game.load.image('wifi_logo1', 'assets/images/wifi_logo1.png');
    game.load.image('wifi_logo2', 'assets/images/wifi_logo2.png');
    game.load.image('wifi_logo3', 'assets/images/wifi_logo3.png');
    game.load.script('canvasinput', 'assets/js/CanvasInput.min.js');
  }



create () {
    text = game.add.text(160, 380, '', { font: "15px Bungee", fill: "black" });
    this.nextLine();

    game.add.text(250, 150, "Wifi Wars", {
        font: "80px Bungee",
        fill: "config.labelColor",
        smoothed: true
      });

  var myInput = this.createInput(600, 330);
      myInput.anchor.set(0.5);
      myInput.canvasInput.focus();

      game.stage.disableVisibilityChange = true;
      var image = game.add.image(415, 120,'wifi_logo0');
      var logoCount = 1;

      var updateImage = () => {
          if (logoCount <= 3) {
            image.loadTexture('wifi_logo' + logoCount++);
          } else {
            logoCount = 0;
            image.loadTexture('wifi_logo' + logoCount++);
          }
      };

      logoInterval = setInterval(updateImage, 900);

      snd = game.add.audio('bg_sound_monody');
      snd.loop = true;
      snd.volume = 0.5;
      snd.play();
   }
    inputFocus(sprite){
        sprite.canvasInput.focus();
    }
    createInput(x, y){
    var bmd = this.add.bitmapData(500, 100);
    var myInput = this.game.add.sprite(x, y, bmd);
    var state = this.state;
    var game = this.game;
    myInput.canvasInput = new CanvasInput({
      canvas: bmd.canvas,
      fontSize: 20,
      fontFamily: 'Bungee',
      fontColor: '#212121',
      width: 220,
      padding: 8,
      borderWidth: 1,
      borderColor: '#000',
      borderRadius: 1,
      boxShadow: '1px 1px 1px #fff',
      innerShadow: '0px 0px 0px rgba(0, 0, 0, 0.5)',
      placeHolder: 'Enter your name',
        onkeyup: function(e){
            if (e.key == 'Enter' && this._value != '') {
                clearInterval(logoInterval);
                game.nickname = this._value;
                state.start('Game');
                this.destroy();
            }
        }
    });
    myInput.inputEnabled = true;
    myInput.input.useHandCursor = true;
    myInput.events.onInputUp.add(this.inputFocus, this);

    return myInput;
  }
  nextLine() {

    if (lineIndex === content.length)
    {
        return;
    }

    line = content[lineIndex].split('');
    wordIndex = 0;
    game.time.events.repeat(wordDelay, line.length, this.nextWord, this);
    lineIndex++;

}

  nextWord() {
    text.text = text.text.concat(line[wordIndex] + "");
    wordIndex++;

    if (wordIndex === line.length)
    {
        text.text = text.text.concat("\n");
        game.time.events.add(lineDelay, this.nextLine, this);
    }

}


}
